////////////////////////////////////////////
//  2006 Intelligroup Ltd Gadget Script
////////////////////////////////////////////


xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
xmlDoc2 = new ActiveXObject("Msxml2.DOMDocument.3.0");

////////////////////////////////////////////////////////////////////////////////
//
//
////////////////////////////////////////////////////////////////////////////////

// XML Functions
function getSearch() {
	try {
		var srchURL = "http://musicbrainz.org/ws/1/release/?type=xml&artist=" + System.Gadget.document.getElementById('q').value + "&releasetypes=Album+Official";
		loadXML(srchURL);

		var varResults = xmlObj.getElementsByTagName('release');

		var srchHTML = '<table id="resTable" valign="top" width="100%" cellspacing="10" cellpadding="0"><tr><td colspan="2" class="track"><b>Search results for ' + System.Gadget.document.getElementById('q').value + '</b><br />&nbsp;</td><td center="100%">Relevance</td></tr>';
		for (i=0; i<varResults.length; i++) {

			var resID = varResults[i].getAttribute('id');
			var resScore = varResults[i].getAttribute('ext:score');			
			if (varResults[i].childNodes[2].tagName == "artist") {
				var resArtist = varResults[i].childNodes[2].childNodes[0].text;
				var resASIN = "";
			} else if (varResults[i].childNodes[2].tagName == "asin") {
				var resASIN = varResults[i].childNodes[2].text;
				var resArtist = varResults[i].childNodes[3].childNodes[0].text;
			}
			var resTitle = varResults[i].childNodes[0].text;
			var resImg = "http://images.amazon.com/images/P/" + resASIN + ".01.MZZZZZZZ.jpg";			
			srchHTML += '<tr onclick="retrieveXML(\'' + resID + '\')" onmouseover="style.cursor=\'hand\';">';
			srchHTML += '<td width="80px"><img src="' + resImg + '" width="40" height="40" /></td>';
			srchHTML += '<td>' + resArtist + '<br />' + resTitle +'</td>';
			srchHTML += '<td valign="middle" align="center" width="20px">' + resScore + '%</td>';
			srchHTML += '</tr>';
		}
		srchHTML += '</table>';
		srchContent.innerHTML = srchHTML;
	} catch (e) { srchContent.innerHTML = "No search results found"; }
}

function retrieveXML(x) {
	try {
		var bmURL = "http://musicbrainz.org/ws/1/release/" + x + "?type=xml&inc=artist+discs+tracks+counts+release-events";
		srchContent.style.display = "none";
		loadXML(bmURL);
		var varASIN = xmlObj.getElementsByTagName('asin');
		var varTracks = xmlObj.getElementsByTagName('track-list');
		var varTitle = xmlObj.getElementsByTagName('title');		
		var varArtist = xmlObj.getElementsByTagName('artist');		
		var varDur = xmlObj.getElementsByTagName('duration');
		if (varArtist[0].text) {
			var dInfo = "<h2>" + varArtist[0].childNodes[0].text + "</2>";
			dInfo += "<h3> " + varTitle[0].text + "</h3>";
			discInfo.innerHTML = dInfo;
		}
		var amzLink = '<iframe src="http://rcm.amazon.com/e/cm?t=windowsvistag-20&o=1&p=13&l=st1&mode=music&search=' + varArtist[0].childNodes[0].text + '&nou=1&fc1=FFFFFF&lt1=_blank&lc1=CCFFFF&bg1=000000&f=ifr" marginwidth="0" marginheight="0" width="468" height="60" border="0" frameborder="0" style="border:none;" scrolling="no"></iframe>'
		divAmz.innerHTML = amzLink;
		if (varASIN[0].text) {
			var amzImg = "http://images.amazon.com/images/P/" + varASIN[0].text + ".01.MZZZZZZZ.jpg";
			albumArt.innerHTML = "<img src=\"" + amzImg + "\" />";
		} 
		var tlHTML   = '<table valign="top" width="100%" cellspacing="5" cellpadding="0"><tr><td colspan="2" class="track"><b>Track Listing</b></td></tr>';
		var tlHTML2  = '<table valign="top" width="100%" cellspacing="5" cellpadding="0"><tr><td colspan="2" class="track">&nbsp;</td></tr>';		
		for (i=0; i<varTracks[0].childNodes.length; i++) {
			if(varTracks[0].childNodes[i].childNodes[0].text) {
				tNum = i + 1;
				var trTime = varTracks[0].childNodes[i].childNodes[1].text;
				var minutes = Math.floor(trTime / 1000 / 60);
				trTime = trTime % 60000;
				var seconds = String(Math.round(trTime / 1000));
				if (seconds.length < 2) { seconds = "0" + seconds; }
				trTime = minutes + ":" + seconds;
				if (i < 9) {
					tlHTML += "<tr><td width=\"10px\" align=\"right\" class=\"trackNum\">" + tNum + ".<td class=\"track\">" + varTracks[0].childNodes[i].childNodes[0].text + " <i>(" + trTime + ")</i></td>";
					tlHTML += "</tr>";
				} else {
					tlHTML2 += "<tr><td width=\"10px\" align=\"right\" class=\"trackNum\">" + tNum + ".<td class=\"track\">" + varTracks[0].childNodes[i].childNodes[0].text + " <i>(" + trTime + ")</i></td>";
					tlHTML2 += "</tr>";
				} 
			}
		}
		tlHTML  += '</table>';		
		tlHTML2  += '</table>';				
		trackList.innerHTML = tlHTML;
		trackList2.innerHTML = tlHTML2;		
	} catch (e) { }
}

function loadXML(xmlFile) { 
	xmlDoc.async = "false";
	xmlDoc.onreadystatechange = verify;
	xmlDoc.load(xmlFile);
	xmlObj = xmlDoc.documentElement;
}

function verify() { 
	if (xmlDoc.readyState != 4) 
	{ 
		return false;
	} 
}